# -*- coding: utf-8 -*-

"""
    api_tester_upload_test

    This file was automatically generated by APIMATIC v2.0 ( https://apimatic.io ).
"""

from api_tester_upload_test.api_helper import APIHelper
from api_tester_upload_test.configuration import Configuration
from api_tester_upload_test.controllers.base_controller import BaseController
from api_tester_upload_test.http.auth.o_auth_2 import OAuth2
from api_tester_upload_test.models.list_file_versions_response import ListFileVersionsResponse
from api_tester_upload_test.models.copy_and_move_file_response import CopyAndMoveFileResponse
from api_tester_upload_test.models.list_single_file_version_response import ListSingleFileVersionResponse
from api_tester_upload_test.models.delete_file_response import DeleteFileResponse
from api_tester_upload_test.exceptions.api_exception import APIException

class FileOperationsController(BaseController):

    """A Controller to access Endpoints in the api_tester_upload_test API."""


    def list_file_versions(self,
                           path,
                           start_version=None,
                           stop_version=None,
                           limit=None):
        """Does a GET request to /v2/files/{path}/versions.

        TODO: type endpoint description here.

        Args:
            path (string): TODO: type description here. Example: 
            start_version (int, optional): TODO: type description here.
                Example: 
            stop_version (int, optional): TODO: type description here.
                Example: 
            limit (int, optional): TODO: type description here. Example: 

        Returns:
            ListFileVersionsResponse: Response from the API. 

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        # Prepare query URL
        _url_path = '/v2/files/{path}/versions'
        _url_path = APIHelper.append_url_with_template_parameters(_url_path, { 
            'path': path
        })
        _query_builder = Configuration.base_uri.format(Configuration.account_id)
        _query_builder += _url_path
        _query_parameters = {
            'start-version': start_version,
            'stop-version': stop_version,
            'limit': limit
        }
        _query_builder = APIHelper.append_url_with_query_parameters(_query_builder,
            _query_parameters, Configuration.array_serialization)
        _query_url = APIHelper.clean_url(_query_builder)

        # Prepare headers
        _headers = {
            'accept': 'application/json'
        }

        # Prepare and execute request
        _request = self.http_client.get(_query_url, headers=_headers)
        OAuth2.apply(_request)
        _context = self.execute_request(_request)
        self.validate_response(_context)

        # Return appropriate type
        return APIHelper.json_deserialize(_context.response.raw_body, ListFileVersionsResponse.from_dictionary)

    def create_move_file(self,
                         path,
                         to,
                         name=None,
                         exists=None):
        """Does a POST request to /v2/files/{path}?operation=move.

        TODO: type endpoint description here.

        Args:
            path (string): TODO: type description here. Example: 
            to (string): TODO: type description here. Example: 
            name (string, optional): TODO: type description here. Example: 
            exists (ExistsEnum, optional): TODO: type description here.
                Example: 

        Returns:
            CopyAndMoveFileResponse: Response from the API. 

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        # Prepare query URL
        _url_path = '/v2/files/{path}?operation=move'
        _url_path = APIHelper.append_url_with_template_parameters(_url_path, { 
            'path': path
        })
        _query_builder = Configuration.base_uri.format(Configuration.account_id)
        _query_builder += _url_path
        _query_url = APIHelper.clean_url(_query_builder)

        # Prepare headers
        _headers = {
            'accept': 'application/json'
        }

        # Prepare form parameters
        _form_parameters = {
            'to': to,
            'name': name,
            'exists': exists
        }

        # Prepare and execute request
        _request = self.http_client.post(_query_url, headers=_headers, parameters=_form_parameters)
        OAuth2.apply(_request)
        _context = self.execute_request(_request)
        self.validate_response(_context)

        # Return appropriate type
        return APIHelper.json_deserialize(_context.response.raw_body, CopyAndMoveFileResponse.from_dictionary)

    def create_copy_file(self,
                         path,
                         to,
                         name,
                         exists='rename'):
        """Does a POST request to /v2/files/{path}?operation=copy.

        TODO: type endpoint description here.

        Args:
            path (string): TODO: type description here. Example: 
            to (string): TODO: type description here. Example: 
            name (string): TODO: type description here. Example: 
            exists (ExistsEnum, optional): TODO: type description here.
                Example: rename

        Returns:
            CopyAndMoveFileResponse: Response from the API. 

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        # Prepare query URL
        _url_path = '/v2/files/{path}?operation=copy'
        _url_path = APIHelper.append_url_with_template_parameters(_url_path, { 
            'path': path
        })
        _query_builder = Configuration.base_uri.format(Configuration.account_id)
        _query_builder += _url_path
        _query_url = APIHelper.clean_url(_query_builder)

        # Prepare headers
        _headers = {
            'accept': 'application/json'
        }

        # Prepare form parameters
        _form_parameters = {
            'to': to,
            'name': name,
            'exists': exists
        }

        # Prepare and execute request
        _request = self.http_client.post(_query_url, headers=_headers, parameters=_form_parameters)
        OAuth2.apply(_request)
        _context = self.execute_request(_request)
        self.validate_response(_context)

        # Return appropriate type
        return APIHelper.json_deserialize(_context.response.raw_body, CopyAndMoveFileResponse.from_dictionary)

    def get_download_file(self,
                          path,
                          range=None,
                          version=None,
                          version_conflict=None):
        """Does a GET request to /v2/files/{path}/.

        TODO: type endpoint description here.

        Args:
            path (string): Base64-encoded path to any location in the
                authenticated user�s account.
            range (string, optional): TODO: type description here. Example: 
            version (int, optional): TODO: type description here. Example: 
            version_conflict (string, optional): TODO: type description here.
                Example: 

        Returns:
            void: Response from the API. 

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        # Prepare query URL
        _url_path = '/v2/files/{path}/'
        _url_path = APIHelper.append_url_with_template_parameters(_url_path, { 
            'path': path
        })
        _query_builder = Configuration.base_uri.format(Configuration.account_id)
        _query_builder += _url_path
        _query_parameters = {
            'version': version,
            'version-conflict': version_conflict
        }
        _query_builder = APIHelper.append_url_with_query_parameters(_query_builder,
            _query_parameters, Configuration.array_serialization)
        _query_url = APIHelper.clean_url(_query_builder)

        # Prepare headers
        _headers = {
            'Range': range
        }

        # Prepare and execute request
        _request = self.http_client.get(_query_url, headers=_headers)
        OAuth2.apply(_request)
        _context = self.execute_request(_request)

        # Endpoint and global error handling using HTTP status codes.
        if _context.response.status_code == 400:
            raise APIException('Version was not supplied, or version was not the current version.', _context)
        self.validate_response(_context)

    def create_promote_file_version(self,
                                    path,
                                    version):
        """Does a POST request to /v2/files/{path}/versions/{version}?operation=promote.

        TODO: type endpoint description here.

        Args:
            path (string): TODO: type description here. Example: 
            version (int): TODO: type description here. Example: 

        Returns:
            ListSingleFileVersionResponse: Response from the API. 

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        # Prepare query URL
        _url_path = '/v2/files/{path}/versions/{version}?operation=promote'
        _url_path = APIHelper.append_url_with_template_parameters(_url_path, { 
            'path': path,
            'version': version
        })
        _query_builder = Configuration.base_uri.format(Configuration.account_id)
        _query_builder += _url_path
        _query_url = APIHelper.clean_url(_query_builder)

        # Prepare headers
        _headers = {
            'accept': 'application/json'
        }

        # Prepare and execute request
        _request = self.http_client.post(_query_url, headers=_headers)
        OAuth2.apply(_request)
        _context = self.execute_request(_request)
        self.validate_response(_context)

        # Return appropriate type
        return APIHelper.json_deserialize(_context.response.raw_body, ListSingleFileVersionResponse.from_dictionary)

    def get_file_meta(self,
                      path):
        """Does a GET request to /v2/files/{path}/meta.

        TODO: type endpoint description here.

        Args:
            path (string): TODO: type description here. Example: 

        Returns:
            ListSingleFileVersionResponse: Response from the API. 

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        # Prepare query URL
        _url_path = '/v2/files/{path}/meta'
        _url_path = APIHelper.append_url_with_template_parameters(_url_path, { 
            'path': path
        })
        _query_builder = Configuration.base_uri.format(Configuration.account_id)
        _query_builder += _url_path
        _query_url = APIHelper.clean_url(_query_builder)

        # Prepare headers
        _headers = {
            'accept': 'application/json'
        }

        # Prepare and execute request
        _request = self.http_client.get(_query_url, headers=_headers)
        OAuth2.apply(_request)
        _context = self.execute_request(_request)
        self.validate_response(_context)

        # Return appropriate type
        return APIHelper.json_deserialize(_context.response.raw_body, ListSingleFileVersionResponse.from_dictionary)

    def list_single_file_version(self,
                                 path,
                                 version):
        """Does a GET request to /v2/files/{path}/versions/{version}.

        TODO: type endpoint description here.

        Args:
            path (string): TODO: type description here. Example: 
            version (int): TODO: type description here. Example: 

        Returns:
            ListSingleFileVersionResponse: Response from the API. 

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        # Prepare query URL
        _url_path = '/v2/files/{path}/versions/{version}'
        _url_path = APIHelper.append_url_with_template_parameters(_url_path, { 
            'path': path,
            'version': version
        })
        _query_builder = Configuration.base_uri.format(Configuration.account_id)
        _query_builder += _url_path
        _query_url = APIHelper.clean_url(_query_builder)

        # Prepare headers
        _headers = {
            'accept': 'application/json'
        }

        # Prepare and execute request
        _request = self.http_client.get(_query_url, headers=_headers)
        OAuth2.apply(_request)
        _context = self.execute_request(_request)
        self.validate_response(_context)

        # Return appropriate type
        return APIHelper.json_deserialize(_context.response.raw_body, ListSingleFileVersionResponse.from_dictionary)

    def delete_file(self,
                    path,
                    commit='false'):
        """Does a DELETE request to /v2/files/{path}/.

        TODO: type endpoint description here.

        Args:
            path (string): TODO: type description here. Example: 
            commit (string, optional): TODO: type description here. Example:
                false

        Returns:
            DeleteFileResponse: Response from the API. 

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        # Prepare query URL
        _url_path = '/v2/files/{path}/'
        _url_path = APIHelper.append_url_with_template_parameters(_url_path, { 
            'path': path
        })
        _query_builder = Configuration.base_uri.format(Configuration.account_id)
        _query_builder += _url_path
        _query_parameters = {
            'commit': commit
        }
        _query_builder = APIHelper.append_url_with_query_parameters(_query_builder,
            _query_parameters, Configuration.array_serialization)
        _query_url = APIHelper.clean_url(_query_builder)

        # Prepare headers
        _headers = {
            'accept': 'application/json'
        }

        # Prepare and execute request
        _request = self.http_client.delete(_query_url, headers=_headers)
        OAuth2.apply(_request)
        _context = self.execute_request(_request)
        self.validate_response(_context)

        # Return appropriate type
        return APIHelper.json_deserialize(_context.response.raw_body, DeleteFileResponse.from_dictionary)

    def create_after_file_meta(self,
                               path,
                               name=None,
                               extension=None,
                               date_created=None,
                               date_meta_last_modified=None,
                               date_content_last_modified=None,
                               mime=None,
                               application_data=None,
                               version=None,
                               version_conflict=None):
        """Does a POST request to /v2/files/{path}/meta.

        TODO: type endpoint description here.

        Args:
            path (string): TODO: type description here. Example: 
            name (string, optional): TODO: type description here. Example: 
            extension (string, optional): TODO: type description here.
                Example: 
            date_created (datetime, optional): TODO: type description here.
                Example: 
            date_meta_last_modified (datetime, optional): TODO: type
                description here. Example: 
            date_content_last_modified (datetime, optional): TODO: type
                description here. Example: 
            mime (string, optional): TODO: type description here. Example: 
            application_data (object, optional): TODO: type description here.
                Example: 
            version (int, optional): TODO: type description here. Example: 
            version_conflict (string, optional): TODO: type description here.
                Example: 

        Returns:
            ListSingleFileVersionResponse: Response from the API. 

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        # Prepare query URL
        _url_path = '/v2/files/{path}/meta'
        _url_path = APIHelper.append_url_with_template_parameters(_url_path, { 
            'path': path
        })
        _query_builder = Configuration.base_uri.format(Configuration.account_id)
        _query_builder += _url_path
        _query_url = APIHelper.clean_url(_query_builder)

        # Prepare headers
        _headers = {
            'accept': 'application/json'
        }

        # Prepare form parameters
        _form_parameters = {
            'name': name,
            'extension': extension,
            'date_created': APIHelper.when_defined(APIHelper.RFC3339DateTime, date_created),
            'date_meta_last_modified': APIHelper.when_defined(APIHelper.RFC3339DateTime, date_meta_last_modified),
            'date_content_last_modified': APIHelper.when_defined(APIHelper.RFC3339DateTime, date_content_last_modified),
            'mime': mime,
            'application_data': application_data,
            'version': version,
            'version-conflict': version_conflict
        }

        # Prepare and execute request
        _request = self.http_client.post(_query_url, headers=_headers, parameters=_form_parameters)
        OAuth2.apply(_request)
        _context = self.execute_request(_request)
        self.validate_response(_context)

        # Return appropriate type
        return APIHelper.json_deserialize(_context.response.raw_body, ListSingleFileVersionResponse.from_dictionary)
