# -*- coding: utf-8 -*-

"""
    api_tester_upload_test

    This file was automatically generated by APIMATIC v2.0 ( https://apimatic.io ).
"""

from api_tester_upload_test.api_helper import APIHelper
from api_tester_upload_test.configuration import Configuration
from api_tester_upload_test.controllers.base_controller import BaseController
from api_tester_upload_test.http.auth.o_auth_2 import OAuth2
from api_tester_upload_test.models.receive_and_unlock_share_response import ReceiveAndUnlockShareResponse
from api_tester_upload_test.models.create_and_alter_share_response import CreateAndAlterShareResponse
from api_tester_upload_test.models.browse_share_response import BrowseShareResponse
from api_tester_upload_test.models.list_share_response import ListShareResponse

class ShareOperationsController(BaseController):

    """A Controller to access Endpoints in the api_tester_upload_test API."""


    def create_unlock_share(self,
                            share_key,
                            password):
        """Does a POST request to /v2/shares/{share_key}/unlock.

        TODO: type endpoint description here.

        Args:
            share_key (string): TODO: type description here. Example: 
            password (string): TODO: type description here. Example: 

        Returns:
            ReceiveAndUnlockShareResponse: Response from the API. 

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        # Prepare query URL
        _url_path = '/v2/shares/{share_key}/unlock'
        _url_path = APIHelper.append_url_with_template_parameters(_url_path, { 
            'share_key': share_key
        })
        _query_builder = Configuration.base_uri.format(Configuration.account_id)
        _query_builder += _url_path
        _query_url = APIHelper.clean_url(_query_builder)

        # Prepare headers
        _headers = {
            'accept': 'application/json'
        }

        # Prepare form parameters
        _form_parameters = {
            'password': password
        }

        # Prepare and execute request
        _request = self.http_client.post(_query_url, headers=_headers, parameters=_form_parameters)
        OAuth2.apply(_request)
        _context = self.execute_request(_request)
        self.validate_response(_context)

        # Return appropriate type
        return APIHelper.json_deserialize(_context.response.raw_body, ReceiveAndUnlockShareResponse.from_dictionary)

    def create_receive_share(self,
                             share_key,
                             path=None,
                             exists=None):
        """Does a POST request to /v2/shares/{share_key}/.

        TODO: type endpoint description here.

        Args:
            share_key (string): TODO: type description here. Example: 
            path (string, optional): TODO: type description here. Example: 
            exists (ExistsEnum, optional): TODO: type description here.
                Example: 

        Returns:
            ReceiveAndUnlockShareResponse: Response from the API. 

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        # Prepare query URL
        _url_path = '/v2/shares/{share_key}/'
        _url_path = APIHelper.append_url_with_template_parameters(_url_path, { 
            'share_key': share_key
        })
        _query_builder = Configuration.base_uri.format(Configuration.account_id)
        _query_builder += _url_path
        _query_url = APIHelper.clean_url(_query_builder)

        # Prepare headers
        _headers = {
            'accept': 'application/json'
        }

        # Prepare form parameters
        _form_parameters = {
            'path': path,
            'exists': exists
        }

        # Prepare and execute request
        _request = self.http_client.post(_query_url, headers=_headers, parameters=_form_parameters)
        OAuth2.apply(_request)
        _context = self.execute_request(_request)
        self.validate_response(_context)

        # Return appropriate type
        return APIHelper.json_deserialize(_context.response.raw_body, ReceiveAndUnlockShareResponse.from_dictionary)

    def delete_share(self,
                     share_key):
        """Does a DELETE request to /v2/shares/{share_key}/.

        TODO: type endpoint description here.

        Args:
            share_key (string): TODO: type description here. Example: 

        Returns:
            void: Response from the API. 

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        # Prepare query URL
        _url_path = '/v2/shares/{share_key}/'
        _url_path = APIHelper.append_url_with_template_parameters(_url_path, { 
            'share_key': share_key
        })
        _query_builder = Configuration.base_uri.format(Configuration.account_id)
        _query_builder += _url_path
        _query_url = APIHelper.clean_url(_query_builder)

        # Prepare and execute request
        _request = self.http_client.delete(_query_url)
        OAuth2.apply(_request)
        _context = self.execute_request(_request)
        self.validate_response(_context)

    def alter_share_info(self,
                         share_key,
                         current_password=None,
                         password=None,
                         name=None):
        """Does a POST request to /v2/shares/{share_key}/info.

        TODO: type endpoint description here.

        Args:
            share_key (string): TODO: type description here. Example: 
            current_password (string, optional): TODO: type description here.
                Example: 
            password (string, optional): TODO: type description here. Example:
                            name (string, optional): TODO: type description here. Example: 

        Returns:
            CreateAndAlterShareResponse: Response from the API. 

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        # Prepare query URL
        _url_path = '/v2/shares/{share_key}/info'
        _url_path = APIHelper.append_url_with_template_parameters(_url_path, { 
            'share_key': share_key
        })
        _query_builder = Configuration.base_uri.format(Configuration.account_id)
        _query_builder += _url_path
        _query_url = APIHelper.clean_url(_query_builder)

        # Prepare headers
        _headers = {
            'accept': 'application/json'
        }

        # Prepare form parameters
        _form_parameters = {
            'current_password': current_password,
            'password': password,
            'name': name
        }

        # Prepare and execute request
        _request = self.http_client.post(_query_url, headers=_headers, parameters=_form_parameters)
        OAuth2.apply(_request)
        _context = self.execute_request(_request)
        self.validate_response(_context)

        # Return appropriate type
        return APIHelper.json_deserialize(_context.response.raw_body, CreateAndAlterShareResponse.from_dictionary)

    def get_browse_share(self,
                         share_key,
                         path=None):
        """Does a GET request to /v2/shares/{share_key}/{path}/meta.

        TODO: type endpoint description here.

        Args:
            share_key (string): TODO: type description here. Example: 
            path (string, optional): TODO: type description here. Example: 

        Returns:
            BrowseShareResponse: Response from the API. 

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        # Prepare query URL
        _url_path = '/v2/shares/{share_key}/{path}/meta'
        _url_path = APIHelper.append_url_with_template_parameters(_url_path, { 
            'share_key': share_key,
            'path': path
        })
        _query_builder = Configuration.base_uri.format(Configuration.account_id)
        _query_builder += _url_path
        _query_url = APIHelper.clean_url(_query_builder)

        # Prepare headers
        _headers = {
            'accept': 'application/json'
        }

        # Prepare and execute request
        _request = self.http_client.get(_query_url, headers=_headers)
        OAuth2.apply(_request)
        _context = self.execute_request(_request)
        self.validate_response(_context)

        # Return appropriate type
        return APIHelper.json_deserialize(_context.response.raw_body, BrowseShareResponse.from_dictionary)

    def create_share(self,
                     path):
        """Does a POST request to /v2/shares/.

        TODO: type endpoint description here.

        Args:
            path (string): TODO: type description here. Example: 

        Returns:
            CreateAndAlterShareResponse: Response from the API. 

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        # Prepare query URL
        _url_path = '/v2/shares/'
        _query_builder = Configuration.base_uri.format(Configuration.account_id)
        _query_builder += _url_path
        _query_url = APIHelper.clean_url(_query_builder)

        # Prepare headers
        _headers = {
            'accept': 'application/json'
        }

        # Prepare form parameters
        _form_parameters = {
            'path': path
        }

        # Prepare and execute request
        _request = self.http_client.post(_query_url, headers=_headers, parameters=_form_parameters)
        OAuth2.apply(_request)
        _context = self.execute_request(_request)
        self.validate_response(_context)

        # Return appropriate type
        return APIHelper.json_deserialize(_context.response.raw_body, CreateAndAlterShareResponse.from_dictionary)

    def list_shares(self):
        """Does a GET request to /v2/shares/.

        TODO: type endpoint description here.

        Returns:
            ListShareResponse: Response from the API. 

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        # Prepare query URL
        _url_path = '/v2/shares/'
        _query_builder = Configuration.base_uri.format(Configuration.account_id)
        _query_builder += _url_path
        _query_url = APIHelper.clean_url(_query_builder)

        # Prepare headers
        _headers = {
            'accept': 'application/json'
        }

        # Prepare and execute request
        _request = self.http_client.get(_query_url, headers=_headers)
        OAuth2.apply(_request)
        _context = self.execute_request(_request)
        self.validate_response(_context)

        # Return appropriate type
        return APIHelper.json_deserialize(_context.response.raw_body, ListShareResponse.from_dictionary)
