# -*- coding: utf-8 -*-

"""
    api_tester_upload_test

    This file was automatically generated by APIMATIC v2.0 ( https://apimatic.io ).
"""

from api_tester_upload_test.api_helper import APIHelper
from api_tester_upload_test.configuration import Configuration
from api_tester_upload_test.controllers.base_controller import BaseController
from api_tester_upload_test.http.auth.o_auth_2 import OAuth2
from api_tester_upload_test.models.browse_trash_response import BrowseTrashResponse

class TrashOperationsController(BaseController):

    """A Controller to access Endpoints in the api_tester_upload_test API."""


    def delete_trash_items(self,
                           path):
        """Does a DELETE request to /v2/trash/{path}.

        TODO: type endpoint description here.

        Args:
            path (string): TODO: type description here. Example: 

        Returns:
            void: Response from the API. 

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        # Prepare query URL
        _url_path = '/v2/trash/{path}'
        _url_path = APIHelper.append_url_with_template_parameters(_url_path, { 
            'path': path
        })
        _query_builder = Configuration.base_uri.format(Configuration.account_id)
        _query_builder += _url_path
        _query_url = APIHelper.clean_url(_query_builder)

        # Prepare and execute request
        _request = self.http_client.delete(_query_url)
        OAuth2.apply(_request)
        _context = self.execute_request(_request)
        self.validate_response(_context)

    def get_browse_trash(self,
                         path):
        """Does a GET request to /v2/trash/{path}.

        TODO: type endpoint description here.

        Args:
            path (string): TODO: type description here. Example: 

        Returns:
            BrowseTrashResponse: Response from the API. 

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        # Prepare query URL
        _url_path = '/v2/trash/{path}'
        _url_path = APIHelper.append_url_with_template_parameters(_url_path, { 
            'path': path
        })
        _query_builder = Configuration.base_uri.format(Configuration.account_id)
        _query_builder += _url_path
        _query_url = APIHelper.clean_url(_query_builder)

        # Prepare headers
        _headers = {
            'accept': 'application/json'
        }

        # Prepare and execute request
        _request = self.http_client.get(_query_url, headers=_headers)
        OAuth2.apply(_request)
        _context = self.execute_request(_request)
        self.validate_response(_context)

        # Return appropriate type
        return APIHelper.json_deserialize(_context.response.raw_body, BrowseTrashResponse.from_dictionary)

    def create_recover_trash_items(self,
                                   path,
                                   restore=None,
                                   rescue_path=None,
                                   recreate_path=None):
        """Does a POST request to /v2/trash/{path}.

        TODO: type endpoint description here.

        Args:
            path (string): TODO: type description here. Example: 
            restore (string, optional): TODO: type description here. Example:
                            rescue_path (string, optional): TODO: type description here.
                Example: 
            recreate_path (string, optional): TODO: type description here.
                Example: 

        Returns:
            void: Response from the API. 

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        # Prepare query URL
        _url_path = '/v2/trash/{path}'
        _url_path = APIHelper.append_url_with_template_parameters(_url_path, { 
            'path': path
        })
        _query_builder = Configuration.base_uri.format(Configuration.account_id)
        _query_builder += _url_path
        _query_url = APIHelper.clean_url(_query_builder)

        # Prepare form parameters
        _form_parameters = {
            'restore': restore,
            'rescue-path': rescue_path,
            'recreate-path': recreate_path
        }

        # Prepare and execute request
        _request = self.http_client.post(_query_url, parameters=_form_parameters)
        OAuth2.apply(_request)
        _context = self.execute_request(_request)
        self.validate_response(_context)
